%define anolis_release 4
%global enginesdir %(pkg-config --variable=enginesdir libcrypto)
%global githubname QAT_Engine

Name:           qatengine
Version:        1.2.0
Release:        %{anolis_release}%{?dist}
Summary:        Intel® QuickAssist Technology OpenSSL* Engine(QAT_Engine)
License:        BSD and OpenSSL
URL:            https://github.com/intel/%{githubname}
Source0:        https://github.com/intel/%{githubname}/archive/v%{version}/v%{version}.tar.gz
Patch1000:      1000-add-amd-CPU-for-qat_sw.patch

BuildRequires:  gcc make pkg-config autoconf automake libtool openssl-devel
BuildRequires:  intel-ipp-crypto-mb-devel intel-ipsec-mb-devel intel-QAT20-devel udma-devel

ExclusiveArch:  x86_64

%description
The %{name} provides the Intel QuickAssist Technology OpenSSL Engine (an
OpenSSL Plug-In Engine). Intel® QuickAssist Technology OpenSSL* Engine
(QAT_Engine) supports acceleration for both hardware as well as optimized
software based on vectorized instructions. This change starting with the
3rd Generation Intel® Xeon® Scalable Processors family provides users more
options to accelerate their workloads. The QAT OpenSSL* engine now supports
the ability to accelerate from the stand OpenSSL* to basic Intel instruction
set, to either Hardware acceleration path (via the qat_hw path) or via the
optimized SW path (qat_sw lib). 

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{githubname}-%{version} -p1

%build
%configure --with-qat_hw_dir=/usr/include/qat --enable-qat_sw
%make_build

%install
%make_install
rm -rf %{buildroot}/%{_libdir}/engines-1.1/qatengine.la

%files
%license LICENSE*
%{enginesdir}/%{name}.so

%files doc
%doc README.md docs*

%changelog
* Thu Jan 23 2025 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-4
- Openssl 3.x doesn't support tls v1.0 & v1.1, revert the former patch.

* Tue Jul 23 2024 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-3
- Override the pkg-config settings and forcibly utilize OpenSSL 3.x versions during the compilation process

* Wed May 22 2024 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-2
- Add amd CPU for qat_sw

* Wed Aug 16 2023 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-1
- Add build requires intel-QAT20-devel
- enable qat_hw and qat_sw

* Sat Apr 15 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 0.6.16-4
- Refact spec

* Tue Oct 25 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.16-3
- enable qat_sw and disable qat_hw

* Tue Oct 18 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.16-2
- delete scripts of la and change abi.

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.16-1
- Init package from upstream
